;
;
;

;
; Directives de l'ASSEMBLEUR
;
.686P												;; minimum = pentium pro (ou 2) avec le mode privilegi
.MMX													;; pour activer les instructions mmx
.XMM													;; pour activer les instructions sse,sse2 (donc l pentium 3 minimum)
.MODEL flat, stdcall
.STACK 4096

OPTION SCOPED											;; les labels locaux sont autoriss, et les labels globaux  l'intrieur des procdures doivent tre dfinis avec 2 fois 2 points (LABEL::)
OPTION LJMP											;; lors de la compilation, le compileur prviendra si un jmp pourra tre court (SHORT)
OPTION CASEMAP:NONE										;; optionel: rends les identifiants sensibles  la casse de caractres


;
; fichiers INCLUDE
;
INCLUDE \Masm32\INCLUDE\windows.inc
INCLUDE \Masm32\INCLUDE\kernel32.inc
INCLUDE \MAsm32\INCLUDE\masm32.inc
INCLUDE \Masm32\INCLUDE\user32.inc
INCLUDE \Masm32\INCLUDE\gdi32.inc
INCLUDE \Masm32\INCLUDE\Comctl32.inc
INCLUDE \Masm32\INCLUDE\comdlg32.inc
;INCLUDE \Masm32\INCLUDE\ole32.inc
;INCLUDE \Masm32\INCLUDE\oleaut32.inc
;INCLUDE \Masm32\INCLUDE\winmm.inc
;INCLUDE \Masm32\INCLUDE\shell32.inc
;INCLUDE \Masm32\INCLUDE\ .inc


;
; Fichiers LIBRAIRIES
;
INCLUDELIB \Masm32\LIB\kernel32.lib
INCLUDELIB \Masm32\LIB\user32.lib
INCLUDELIB \MAsm32\LIB\masm32.lib
INCLUDELIB \Masm32\LIB\gdi32.lib
INCLUDELIB \Masm32\LIB\Comctl32.lib
INCLUDELIB \Masm32\LIB\comdlg32.lib
;INCLUDELIB \Masm32\LIB\ole32.lib
;INCLUDELIB \Masm32\LIB\oleaut32.lib
;INCLUDELIB \Masm32\LIB\winmm.lib
;INCLUDELIB \Masm32\LIB\shell32.lib
;INCLUDELIB \Masm32\LIB\ .lib


;
; les equivalences
;
Rsrc_IDI_Icone_32			equ 532

Rsrc_IDD_Shuffle_Fenetre			equ 1500
Rsrc_IDC_Shuffle_Fenetre_C		equ 1501
Rsrc_IDC_Shuffle_Texte_Resultats	equ 1502
Rsrc_IDC_Shuffle_Texte_Valeurs0	equ 1503
Rsrc_IDC_Shuffle_Texte_Valeurs1	equ 1504
Rsrc_IDC_Shuffle_Resultats		equ 1511
Rsrc_IDC_Shuffle_Instructions		equ 1512
Rsrc_IDC_Shuffle_Valeurs0		equ 1513
Rsrc_IDC_Shuffle_Separation1		equ 1514
Rsrc_IDC_Shuffle_Valeurs1		equ 1515
Rsrc_IDC_Shuffle_Separation2		equ 1516
Rsrc_IDC_Shuffle_Selection		equ 1517

;
Rsrc_IDD_Insuffisant		equ 2100
Rsrc_IDC_Insuffisant_C		equ 2101
Rsrc_IDC_Desole			equ 2102
Rsrc_IDC_Temps_Changer		equ 2103

;
Rsrc_IDD_Quitter			equ 2200
Rsrc_IDC_Quitter_C			equ 2201
Rsrc_IDC_Vraiment_quitter	equ 2202
Rsrc_IDC_Hum_Oui			equ 2203
Rsrc_IDC_Ah_Ca_Non			equ 2204


;
; PROTOS
;

Shuffle_Sse_ConvertirIeeeSimplesEnChaineDecimaleCustomisee	PROTO
Shuffle_ConvertirValeurEnChaineHexa					PROTO
GestionnaireMessagesBoiteDialogueInstructionsShuffle		PROTO :DWORD,:DWORD,:DWORD,:DWORD
GestionnaireMessagesBoitesDialogue						PROTO :DWORD,:DWORD,:DWORD,:DWORD


.DATA
;
; Definition des STRUCTURES
;

; structure pour la cration/la suppression d'une l'instance mmoire
_Informations_Memoire_	STRUCT							;; pour un total de 16 octets
	_Instance_			DWORD ?						;; pointeur de l'instance
	_Taille_Initiale_		DWORD ?						;; taille initiale (dfinie par HeapCreate)
	_Taille_Maximale_		DWORD ?						;; taille maximale (dfinie par HeapCreate)
	_Inutilise_01_			DWORD ?						;; inutilis, pour le moment... (mais ncessaire pour que la structure aligne ce qui suivra)
_Informations_Memoire_	ENDS

; structure pour l'allocation/la libration d'un bloc mmoire
_Bloc_Memoire_	STRUCT									;; pour un total de 16 octets
	_Taille_Du_Bloc_		DWORD ?						;; taille du bloc (moins les 16 octets ncessaires  l'alignement)
	_Pointeur_A_Liberer_	DWORD ?						;; adresse qui sert pour librer/supprimer le bloc
	_Pointeur_			DWORD ?						;; pointeur de la zone utilisable (align sur 16 octets)
	_Inutilise_01_			DWORD ?						;; inutilis, pour le moment... (mais ncessaire pour que la structure aligne ce qui suivra)
_Bloc_Memoire_	ENDS


.DATA
;
; variables pour la boite de dialogue du code de remplacement de division
;
ALIGN 16
Shuffle_Resultats		REAL4 8.0f,8.0f,8.0f,8.0f
Shuffle_Valeurs_0		REAL4 0.0f,1.0f,2.0f,3.0f
Shuffle_Valeurs_1		REAL4 4.0f,5.0f,6.0f,7.0f

Shuffle_Temoin_Selection		DWORD ?

Instance_Application			DWORD ?
Instance_Boite_Dialogue_Principale	DWORD ?
Instance_Boites_Dialogue			DWORD ?
Pointeur_Ligne_Commandes			DWORD ?

Temoins_Boites_De_Dialogue		DWORD ?

Shuffle_Chaine_Resultats		BYTE "8,8,8,8",0
Shuffle_Chaine_Valeurs_0		BYTE "3,2,1,0",0
Shuffle_Chaine_Valeurs_1		BYTE "7,6,5,4",0

Shuffle_Chaines_Imm8		BYTE 256*4 DUP (0)


;
; les variables structures...
;
ALIGN 16
Shuffle_Coordonnees_Fenetre		RECT <?>					;; 4 Dwords (x,y du coin suprieur gauche et x,y du coin infrieur droit)
Informations_Messages_OS			MSG <?>					;; 5 Dwords + 2 Words


.CODE
;
; Macros
;


.CODE
;
; les procdures gnriques
;
INCLUDE GenericProcs.asm


.CODE
;
; les procdures spcifiquement cres pour le programme
;


ALIGN 16
;
; convertir une valeur IEEE en texte au format dcimale sign (format : -x xxx xxx xxx . x xxx xxx xxx)
; Rceptionne : la variable  transformer, et la chaine de caractres
; Retourne : rien
; mov eax,{OFFSET (adresse) de l'oword contenant les valeurs}
; mov edi,{OFFSET (adresse) de la chane de caractres de rception}
; call ConvertirIeeeSimpleEnChaineDecimaleSignee
;
Shuffle_Sse_ConvertirIeeeSimplesEnChaineDecimaleCustomisee PROC
		push eax										;; empiler eax
		push edi										;; empiler edi

;
		movss XMM3,DWORD PTR [eax+12]						;; placer la variable dans XMM0
		movss XMM2,DWORD PTR [eax+8]						;; placer la variable dans XMM1
		movss XMM1,DWORD PTR [eax+4]						;; placer la variable dans XMM2
		movss XMM0,DWORD PTR [eax]						;; placer la variable dans XMM3
;
		cvttss2si eax,XMM3								;; placer l'entier (sans arrondi) de XMM1 dans eax
		add al,"0"									;; ajouter le caractre de base  bl
		mov BYTE PTR [edi],al							;; placer le rsultat  l'adresse en edi
		inc edi										;; incrmenter edi
;
		mov BYTE PTR [edi],","							;; ) placer une virgule de sparation
		inc edi										;; )
;
		cvttss2si eax,XMM2								;; placer l'entier (sans arrondi) de XMM1 dans eax
		add al,"0"									;; ajouter le caractre de base  bl
		mov BYTE PTR [edi],al							;; placer le rsultat  l'adresse en edi
		inc edi										;; incrmenter edi
;
		mov BYTE PTR [edi],","							;; ) placer une virgule de sparation
		inc edi										;; )
;
		cvttss2si eax,XMM1								;; placer l'entier (sans arrondi) de XMM1 dans eax
		add al,"0"									;; ajouter le caractre de base  bl
		mov BYTE PTR [edi],al							;; placer le rsultat  l'adresse en edi
		inc edi										;; incrmenter edi
;
		mov BYTE PTR [edi],","							;; ) placer une virgule de sparation
		inc edi										;; )
;
		cvttss2si eax,XMM0								;; placer l'entier (sans arrondi) de XMM1 dans eax
		add al,"0"									;; ajouter le caractre de base  bl
		mov BYTE PTR [edi],al							;; placer le rsultat  l'adresse en edi
		inc edi										;; incrmenter edi
;
		mov BYTE PTR [edi],0							;; placer le zro final

		pop edi										;; dsempiler edi
		pop eax										;; dsempiler eax
	ret												;; retourner (sortir de la procdure)
Shuffle_Sse_ConvertirIeeeSimplesEnChaineDecimaleCustomisee ENDP


ALIGN 16
;
; convertir un dword en texte au format hexadcimal
;
; Syntaxe :
; mov eax,{la valeur  convertir en chane}
; mov esi,{adresse (offset) de la chaine de caractres  crer}
; call Shuffle_ConvertirValeurEnChaineHexa
;
; Retourne :
; rien
;
Shuffle_ConvertirValeurEnChaineHexa PROC
		push eax										;; empiler eax
		push edx										;; empiler edx
		push esi										;; empiler esi
		push edi										;; empiler edi

;		mov BYTE PTR [esi],"0"							;; (optionnel) placer un "0" en tte de chane pour eviter des erreurs
;		inc esi										;;		) et incrmenter esi
		mov edi,esi									;; sauvegarder l'adresse ou commence le nombre dans edi
Label1:	mov edx,eax									;; rcupre la valeur actuelle
		and edx,0000000Fh								;; conserver les bits necessaires
		cmp edx,10									;; comparer la valeur  10
		jb Label2										;; si infrieur, aller Label2
		add edx,"7"									;; soustraire 10, et ajouter le caractre de base "A"
		jmp Label3									;; sauter a Label3
Label2:	add edx,"0"									;; ajouter le caractre de base
Label3:	mov BYTE PTR [edi],dl							;; sauvegarde du caractre
		shr eax,4										;; dcalage de 4 bits  droite
		inc edi										;; incrmenter edi
		test eax,eax									;; fixer les flags de eax
		jnz Label1									;; tant que eax est diffrent de 0, aller Label1
		mov BYTE PTR [edi],"h"							;; (optionnel) placer le h
		mov BYTE PTR [edi+1],0							;; (optionnel) placer le 0 final
; inverser la chane obtenue
Label4:	dec edi										;; dcrmenter edi
		mov dl,BYTE PTR [esi]							;; placer l'octet  l'adresse en esi dans dl
		mov dh,BYTE PTR [edi]							;; placer l'octet  l'adresse en edi dans dh
		mov BYTE PTR [edi],dl							;; placer dl  l'adresse en edi
		mov BYTE PTR [esi],dh							;; placer dh  l'adresse en esi
		inc esi										;; incrmenter esi
		cmp esi,edi									;; comparer esi  edi
		jb Label4										;; tant que esi est infrieur  edi, aller Label4

		pop edi										;; dsempiler edi
		pop esi										;; dsempiler esi
		pop edx										;; dsempiler edx
		pop eax										;; dsempiler eax
	ret												;; retourner (sortir de la procdure)
Shuffle_ConvertirValeurEnChaineHexa ENDP


ALIGN 16
;
; PROCEDURE DE GESTION DES MESSAGES WINDOWS POUR LA BOITE DE DIALOGUE DES INSTRUCTIONS SHUFFLE
;
GestionnaireMessagesBoiteDialogueInstructionsShuffle PROC HWndGMShu:HWND,Message:UINT,WParam:WPARAM,LParam:LPARAM

		mov eax,Message								;; placer Message en eax (c'est plus rapide si le nombre de tests  effectuer est consquent)

;
; initialisation des controleurs
;
		cmp eax,WM_INITDIALOG							;; comparer eax  WM_INITDIALOG
		jne EviterInitialiserBoiteDeDialogue				;; si ce n'est pas le cas, aller EviterInitialiserBoiteDeDialogue
		invoke LoadIcon,HWndGMShu,Rsrc_IDI_Icone_32
		invoke SetClassLong,HWndGMShu,GCL_HICON,eax

; positionner la fentre sur la droite de notre cran (en la centrant en hauteur)
		mov esi,HWndGMShu								;; ) positionner la fentre outil
		mov edi,OFFSET Shuffle_Coordonnees_Fenetre			;; )
		call PositionnerFenetreOutil						;; )

; afficher les chanes de dpart
		invoke SetDlgItemText,HWndGMShu,Rsrc_IDC_Shuffle_Resultats,ADDR Shuffle_Chaine_Resultats		;; ) assigner les chanes obtenues aux controls correspondants
		invoke SetDlgItemText,HWndGMShu,Rsrc_IDC_Shuffle_Valeurs0,ADDR Shuffle_Chaine_Valeurs_0		;; )
		invoke SetDlgItemText,HWndGMShu,Rsrc_IDC_Shuffle_Valeurs1,ADDR Shuffle_Chaine_Valeurs_1		;; )

; dfinir les chanes des valeurs immdiates
		xor eax,eax									;; effacer eax
		mov esi,OFFSET Shuffle_Chaines_Imm8				;; placer l'adresse du dbut des chanes Imm8 dans esi
GMShuBoucleCreationChaines:
		call Shuffle_ConvertirValeurEnChaineHexa			;; convertir la valeur en eax en chane ascii, que l'on place en esi
		inc eax										;; incrmenter eax
		add esi,BYTE*4									;; augmenter l'adresse en esi de 4 octets
		cmp esi,(OFFSET Shuffle_Chaines_Imm8)+255*4			;; comparer l'adresse  celle de fin prvue
		jle GMShuBoucleCreationChaines					;; tant que c'est infrieur ou gal, aller GMShuBoucleCreationChaines

; afficher les chaines des valeurs immdiates
		mov esi,OFFSET Shuffle_Chaines_Imm8				;; placer l'adresse du dbut des chanes Imm8 dans esi
GMShuBoucleAffichageChaines:
		invoke SendDlgItemMessage,HWndGMShu,Rsrc_IDC_Shuffle_Selection,CB_ADDSTRING,0,esi		;; assigner la chane  la boite combo
		add esi,BYTE*4									;; augmenter l'adresse en esi de 4 octets
		cmp esi,(OFFSET Shuffle_Chaines_Imm8)+255*4			;; comparer l'adresse  celle de fin prvue
		jle GMShuBoucleAffichageChaines					;; tant que c'est infrieur ou gal, aller GMShuBoucleAffichageChaines

; afficher la slection par dfaut
		invoke SendDlgItemMessage,HWndGMShu,Rsrc_IDC_Shuffle_Selection,CB_SETCURSEL,0,ADDR Shuffle_Chaines_Imm8
		invoke SendDlgItemMessage,HWndGMShu,Rsrc_IDC_Shuffle_Selection,CB_SHOWDROPDOWN,0,TRUE

	ret												;; retourner
EviterInitialiserBoiteDeDialogue:


;
; ici, les commandes gnres par la souris sur les menus, ou les controlleurs, grs par windows...
;
		cmp eax,WM_COMMAND								;; une commande est entre ?
		jne GMShuFinCommandes							;; si ce n'est pas le cas, aller GMShuFinCommandes
		mov eax,WParam									;; placer WParam en eax (c'est plus rapide si le nombre de tests  effectuer est consquent)
;


;
; slectionner la valeur immdiate dsire (boite combo)
;
		mov edx,eax									;; copier eax dans edx
		and edx,0FFFFh									;; conserver le word infrieur de edx
		cmp edx,Rsrc_IDC_Shuffle_Selection					;; boite combo ?
		jne GMShuFinCommandes							;; si ce n'est pas le cas, aller GMShuFinCommandes
		mov edx,eax									;; copier eax dans edx
		shr edx,16									;; conserver le word suprieur de eax


;
; un programme est slectionn dans la boite ?
;
		cmp edx,CBN_SELENDOK							;; une ligne est slectionne ?
		jne GMShuFinBoiteCombo							;; si ce n'est pas le cas, aller GMShuFinBoiteCombo
; on lit l'instruction  appliquer, et on l'applique
		invoke SendDlgItemMessage,HWndGMShu,Rsrc_IDC_Shuffle_Selection,CB_GETCURSEL,0,0
		mov Shuffle_Temoin_Selection,eax					;; stoker la valeur de slection
		mov ebx,OFFSET Shuffle_Resultats					;; placer l'adresse de l'oword du rsultat dans ebx
		mov ecx,OFFSET Shuffle_Valeurs_0					;; placer l'adresse de l'oword source 1 dans ecx
		mov edx,OFFSET Shuffle_Valeurs_1					;; placer l'adresse de l'oword source 2 dans edx
		movaps XMM0,OWORD PTR [ecx]						;; lire la valeur source/destination 1
		movaps XMM1,OWORD PTR [edx]						;; lire la valeur 2

;
		cmp eax,00h
		jne GMShuEviterShufps00
		shufps XMM0,XMM1,00h
GMShuEviterShufps00:

;
		cmp eax,01h
		jne GMShuEviterShufps01
		shufps XMM0,XMM1,01h
GMShuEviterShufps01:

;
		cmp eax,02h
		jne GMShuEviterShufps02
		shufps XMM0,XMM1,02h
GMShuEviterShufps02:

;
		cmp eax,03h
		jne GMShuEviterShufps03
		shufps XMM0,XMM1,03h
GMShuEviterShufps03:

;
		cmp eax,04h
		jne GMShuEviterShufps04
		shufps XMM0,XMM1,04h
GMShuEviterShufps04:

;
		cmp eax,05h
		jne GMShuEviterShufps05
		shufps XMM0,XMM1,05h
GMShuEviterShufps05:

;
		cmp eax,06h
		jne GMShuEviterShufps06
		shufps XMM0,XMM1,06h
GMShuEviterShufps06:

;
		cmp eax,07h
		jne GMShuEviterShufps07
		shufps XMM0,XMM1,07h
GMShuEviterShufps07:

;
		cmp eax,08h
		jne GMShuEviterShufps08
		shufps XMM0,XMM1,08h
GMShuEviterShufps08:

;
		cmp eax,09h
		jne GMShuEviterShufps09
		shufps XMM0,XMM1,09h
GMShuEviterShufps09:

;
		cmp eax,0Ah
		jne GMShuEviterShufps0A
		shufps XMM0,XMM1,0Ah
GMShuEviterShufps0A:

;
		cmp eax,0Bh
		jne GMShuEviterShufps0B
		shufps XMM0,XMM1,0Bh
GMShuEviterShufps0B:

;
		cmp eax,0Ch
		jne GMShuEviterShufps0C
		shufps XMM0,XMM1,0Ch
GMShuEviterShufps0C:

;
		cmp eax,0Dh
		jne GMShuEviterShufps0D
		shufps XMM0,XMM1,0Dh
GMShuEviterShufps0D:

;
		cmp eax,0Eh
		jne GMShuEviterShufps0E
		shufps XMM0,XMM1,0Eh
GMShuEviterShufps0E:

;
		cmp eax,0Fh
		jne GMShuEviterShufps0F
		shufps XMM0,XMM1,0Fh
GMShuEviterShufps0F:

;
		cmp eax,10h
		jne GMShuEviterShufps10
		shufps XMM0,XMM1,10h
GMShuEviterShufps10:

;
		cmp eax,11h
		jne GMShuEviterShufps11
		shufps XMM0,XMM1,11h
GMShuEviterShufps11:

;
		cmp eax,12h
		jne GMShuEviterShufps12
		shufps XMM0,XMM1,12h
GMShuEviterShufps12:

;
		cmp eax,13h
		jne GMShuEviterShufps13
		shufps XMM0,XMM1,13h
GMShuEviterShufps13:

;
		cmp eax,14h
		jne GMShuEviterShufps14
		shufps XMM0,XMM1,14h
GMShuEviterShufps14:

;
		cmp eax,15h
		jne GMShuEviterShufps15
		shufps XMM0,XMM1,15h
GMShuEviterShufps15:

;
		cmp eax,16h
		jne GMShuEviterShufps16
		shufps XMM0,XMM1,16h
GMShuEviterShufps16:

;
		cmp eax,17h
		jne GMShuEviterShufps17
		shufps XMM0,XMM1,17h
GMShuEviterShufps17:

;
		cmp eax,18h
		jne GMShuEviterShufps18
		shufps XMM0,XMM1,18h
GMShuEviterShufps18:

;
		cmp eax,19h
		jne GMShuEviterShufps19
		shufps XMM0,XMM1,19h
GMShuEviterShufps19:

;
		cmp eax,1Ah
		jne GMShuEviterShufps1A
		shufps XMM0,XMM1,1Ah
GMShuEviterShufps1A:

;
		cmp eax,1Bh
		jne GMShuEviterShufps1B
		shufps XMM0,XMM1,1Bh
GMShuEviterShufps1B:

;
		cmp eax,1Ch
		jne GMShuEviterShufps1C
		shufps XMM0,XMM1,1Ch
GMShuEviterShufps1C:

;
		cmp eax,1Dh
		jne GMShuEviterShufps1D
		shufps XMM0,XMM1,1Dh
GMShuEviterShufps1D:

;
		cmp eax,1Eh
		jne GMShuEviterShufps1E
		shufps XMM0,XMM1,1Eh
GMShuEviterShufps1E:

;
		cmp eax,1Fh
		jne GMShuEviterShufps1F
		shufps XMM0,XMM1,1Fh
GMShuEviterShufps1F:

;
		cmp eax,20h
		jne GMShuEviterShufps20
		shufps XMM0,XMM1,20h
GMShuEviterShufps20:

;
		cmp eax,21h
		jne GMShuEviterShufps21
		shufps XMM0,XMM1,21h
GMShuEviterShufps21:

;
		cmp eax,22h
		jne GMShuEviterShufps22
		shufps XMM0,XMM1,22h
GMShuEviterShufps22:

;
		cmp eax,23h
		jne GMShuEviterShufps23
		shufps XMM0,XMM1,23h
GMShuEviterShufps23:

;
		cmp eax,24h
		jne GMShuEviterShufps24
		shufps XMM0,XMM1,24h
GMShuEviterShufps24:

;
		cmp eax,25h
		jne GMShuEviterShufps25
		shufps XMM0,XMM1,25h
GMShuEviterShufps25:

;
		cmp eax,26h
		jne GMShuEviterShufps26
		shufps XMM0,XMM1,26h
GMShuEviterShufps26:

;
		cmp eax,27h
		jne GMShuEviterShufps27
		shufps XMM0,XMM1,27h
GMShuEviterShufps27:

;
		cmp eax,28h
		jne GMShuEviterShufps28
		shufps XMM0,XMM1,28h
GMShuEviterShufps28:

;
		cmp eax,29h
		jne GMShuEviterShufps29
		shufps XMM0,XMM1,29h
GMShuEviterShufps29:

;
		cmp eax,2Ah
		jne GMShuEviterShufps2A
		shufps XMM0,XMM1,2Ah
GMShuEviterShufps2A:

;
		cmp eax,2Bh
		jne GMShuEviterShufps2B
		shufps XMM0,XMM1,2Bh
GMShuEviterShufps2B:

;
		cmp eax,2Ch
		jne GMShuEviterShufps2C
		shufps XMM0,XMM1,2Ch
GMShuEviterShufps2C:

;
		cmp eax,2Dh
		jne GMShuEviterShufps2D
		shufps XMM0,XMM1,2Dh
GMShuEviterShufps2D:

;
		cmp eax,2Eh
		jne GMShuEviterShufps2E
		shufps XMM0,XMM1,2Eh
GMShuEviterShufps2E:

;
		cmp eax,2Fh
		jne GMShuEviterShufps2F
		shufps XMM0,XMM1,2Fh
GMShuEviterShufps2F:

;
		cmp eax,30h
		jne GMShuEviterShufps30
		shufps XMM0,XMM1,30h
GMShuEviterShufps30:

;
		cmp eax,31h
		jne GMShuEviterShufps31
		shufps XMM0,XMM1,31h
GMShuEviterShufps31:

;
		cmp eax,32h
		jne GMShuEviterShufps32
		shufps XMM0,XMM1,32h
GMShuEviterShufps32:

;
		cmp eax,33h
		jne GMShuEviterShufps33
		shufps XMM0,XMM1,33h
GMShuEviterShufps33:

;
		cmp eax,34h
		jne GMShuEviterShufps34
		shufps XMM0,XMM1,34h
GMShuEviterShufps34:

;
		cmp eax,35h
		jne GMShuEviterShufps35
		shufps XMM0,XMM1,35h
GMShuEviterShufps35:

;
		cmp eax,36h
		jne GMShuEviterShufps36
		shufps XMM0,XMM1,36h
GMShuEviterShufps36:

;
		cmp eax,37h
		jne GMShuEviterShufps37
		shufps XMM0,XMM1,37h
GMShuEviterShufps37:

;
		cmp eax,38h
		jne GMShuEviterShufps38
		shufps XMM0,XMM1,38h
GMShuEviterShufps38:

;
		cmp eax,39h
		jne GMShuEviterShufps39
		shufps XMM0,XMM1,39h
GMShuEviterShufps39:

;
		cmp eax,3Ah
		jne GMShuEviterShufps3A
		shufps XMM0,XMM1,3Ah
GMShuEviterShufps3A:

;
		cmp eax,3Bh
		jne GMShuEviterShufps3B
		shufps XMM0,XMM1,3Bh
GMShuEviterShufps3B:

;
		cmp eax,3Ch
		jne GMShuEviterShufps3C
		shufps XMM0,XMM1,3Ch
GMShuEviterShufps3C:

;
		cmp eax,3Dh
		jne GMShuEviterShufps3D
		shufps XMM0,XMM1,3Dh
GMShuEviterShufps3D:

;
		cmp eax,3Eh
		jne GMShuEviterShufps3E
		shufps XMM0,XMM1,3Eh
GMShuEviterShufps3E:

;
		cmp eax,3Fh
		jne GMShuEviterShufps3F
		shufps XMM0,XMM1,3Fh
GMShuEviterShufps3F:

;
		cmp eax,40h
		jne GMShuEviterShufps40
		shufps XMM0,XMM1,40h
GMShuEviterShufps40:

;
		cmp eax,41h
		jne GMShuEviterShufps41
		shufps XMM0,XMM1,41h
GMShuEviterShufps41:

;
		cmp eax,42h
		jne GMShuEviterShufps42
		shufps XMM0,XMM1,42h
GMShuEviterShufps42:

;
		cmp eax,43h
		jne GMShuEviterShufps43
		shufps XMM0,XMM1,43h
GMShuEviterShufps43:

;
		cmp eax,44h
		jne GMShuEviterShufps44
		shufps XMM0,XMM1,44h
GMShuEviterShufps44:

;
		cmp eax,45h
		jne GMShuEviterShufps45
		shufps XMM0,XMM1,45h
GMShuEviterShufps45:

;
		cmp eax,46h
		jne GMShuEviterShufps46
		shufps XMM0,XMM1,46h
GMShuEviterShufps46:

;
		cmp eax,47h
		jne GMShuEviterShufps47
		shufps XMM0,XMM1,47h
GMShuEviterShufps47:

;
		cmp eax,48h
		jne GMShuEviterShufps48
		shufps XMM0,XMM1,48h
GMShuEviterShufps48:

;
		cmp eax,49h
		jne GMShuEviterShufps49
		shufps XMM0,XMM1,49h
GMShuEviterShufps49:

;
		cmp eax,4Ah
		jne GMShuEviterShufps4A
		shufps XMM0,XMM1,4Ah
GMShuEviterShufps4A:

;
		cmp eax,4Bh
		jne GMShuEviterShufps4B
		shufps XMM0,XMM1,4Bh
GMShuEviterShufps4B:

;
		cmp eax,4Ch
		jne GMShuEviterShufps4C
		shufps XMM0,XMM1,4Ch
GMShuEviterShufps4C:

;
		cmp eax,4Dh
		jne GMShuEviterShufps4D
		shufps XMM0,XMM1,4Dh
GMShuEviterShufps4D:

;
		cmp eax,4Eh
		jne GMShuEviterShufps4E
		shufps XMM0,XMM1,4Eh
GMShuEviterShufps4E:

;
		cmp eax,4Fh
		jne GMShuEviterShufps4F
		shufps XMM0,XMM1,4Fh
GMShuEviterShufps4F:

;
		cmp eax,50h
		jne GMShuEviterShufps50
		shufps XMM0,XMM1,50h
GMShuEviterShufps50:

;
		cmp eax,51h
		jne GMShuEviterShufps51
		shufps XMM0,XMM1,51h
GMShuEviterShufps51:

;
		cmp eax,52h
		jne GMShuEviterShufps52
		shufps XMM0,XMM1,52h
GMShuEviterShufps52:

;
		cmp eax,53h
		jne GMShuEviterShufps53
		shufps XMM0,XMM1,53h
GMShuEviterShufps53:

;
	cmp eax,54h
	jne GMShuEviterShufps54
	shufps XMM0,XMM1,54h
GMShuEviterShufps54:
	cmp eax,55h
	jne GMShuEviterShufps55
	shufps XMM0,XMM1,55h
GMShuEviterShufps55:
	cmp eax,56h
	jne GMShuEviterShufps56
	shufps XMM0,XMM1,56h
GMShuEviterShufps56:
	cmp eax,57h
	jne GMShuEviterShufps57
	shufps XMM0,XMM1,57h
GMShuEviterShufps57:
	cmp eax,58h
	jne GMShuEviterShufps58
	shufps XMM0,XMM1,58h
GMShuEviterShufps58:
	cmp eax,59h
	jne GMShuEviterShufps59
	shufps XMM0,XMM1,59h
GMShuEviterShufps59:
	cmp eax,5Ah
	jne GMShuEviterShufps5A
	shufps XMM0,XMM1,5Ah
GMShuEviterShufps5A:
	cmp eax,5Bh
	jne GMShuEviterShufps5B
	shufps XMM0,XMM1,5Bh
GMShuEviterShufps5B:
	cmp eax,5Ch
	jne GMShuEviterShufps5C
	shufps XMM0,XMM1,5Ch
GMShuEviterShufps5C:
	cmp eax,5Dh
	jne GMShuEviterShufps5D
	shufps XMM0,XMM1,5Dh
GMShuEviterShufps5D:
	cmp eax,5Eh
	jne GMShuEviterShufps5E
	shufps XMM0,XMM1,5Eh
GMShuEviterShufps5E:
	cmp eax,5Fh
	jne GMShuEviterShufps5F
	shufps XMM0,XMM1,5Fh
GMShuEviterShufps5F:

	cmp eax,60h
	jne GMShuEviterShufps60
	shufps XMM0,XMM1,60h
GMShuEviterShufps60:
	cmp eax,61h
	jne GMShuEviterShufps61
	shufps XMM0,XMM1,61h
GMShuEviterShufps61:
	cmp eax,62h
	jne GMShuEviterShufps62
	shufps XMM0,XMM1,62h
GMShuEviterShufps62:
	cmp eax,63h
	jne GMShuEviterShufps63
	shufps XMM0,XMM1,63h
GMShuEviterShufps63:
	cmp eax,64h
	jne GMShuEviterShufps64
	shufps XMM0,XMM1,64h
GMShuEviterShufps64:
	cmp eax,65h
	jne GMShuEviterShufps65
	shufps XMM0,XMM1,65h
GMShuEviterShufps65:
	cmp eax,66h
	jne GMShuEviterShufps66
	shufps XMM0,XMM1,66h
GMShuEviterShufps66:
	cmp eax,67h
	jne GMShuEviterShufps67
	shufps XMM0,XMM1,67h
GMShuEviterShufps67:
	cmp eax,68h
	jne GMShuEviterShufps68
	shufps XMM0,XMM1,68h
GMShuEviterShufps68:
	cmp eax,69h
	jne GMShuEviterShufps69
	shufps XMM0,XMM1,69h
GMShuEviterShufps69:
	cmp eax,6Ah
	jne GMShuEviterShufps6A
	shufps XMM0,XMM1,6Ah
GMShuEviterShufps6A:
	cmp eax,6Bh
	jne GMShuEviterShufps6B
	shufps XMM0,XMM1,6Bh
GMShuEviterShufps6B:
	cmp eax,6Ch
	jne GMShuEviterShufps6C
	shufps XMM0,XMM1,6Ch
GMShuEviterShufps6C:
	cmp eax,6Dh
	jne GMShuEviterShufps6D
	shufps XMM0,XMM1,6Dh
GMShuEviterShufps6D:
	cmp eax,6Eh
	jne GMShuEviterShufps6E
	shufps XMM0,XMM1,6Eh
GMShuEviterShufps6E:
	cmp eax,6Fh
	jne GMShuEviterShufps6F
	shufps XMM0,XMM1,6Fh
GMShuEviterShufps6F:

	cmp eax,70h
	jne GMShuEviterShufps70
	shufps XMM0,XMM1,70h
GMShuEviterShufps70:
	cmp eax,71h
	jne GMShuEviterShufps71
	shufps XMM0,XMM1,71h
GMShuEviterShufps71:
	cmp eax,72h
	jne GMShuEviterShufps72
	shufps XMM0,XMM1,72h
GMShuEviterShufps72:
	cmp eax,73h
	jne GMShuEviterShufps73
	shufps XMM0,XMM1,73h
GMShuEviterShufps73:
	cmp eax,74h
	jne GMShuEviterShufps74
	shufps XMM0,XMM1,74h
GMShuEviterShufps74:
	cmp eax,75h
	jne GMShuEviterShufps75
	shufps XMM0,XMM1,75h
GMShuEviterShufps75:
	cmp eax,76h
	jne GMShuEviterShufps76
	shufps XMM0,XMM1,76h
GMShuEviterShufps76:
	cmp eax,77h
	jne GMShuEviterShufps77
	shufps XMM0,XMM1,77h
GMShuEviterShufps77:
	cmp eax,78h
	jne GMShuEviterShufps78
	shufps XMM0,XMM1,78h
GMShuEviterShufps78:
	cmp eax,79h
	jne GMShuEviterShufps79
	shufps XMM0,XMM1,79h
GMShuEviterShufps79:
	cmp eax,7Ah
	jne GMShuEviterShufps7A
	shufps XMM0,XMM1,7Ah
GMShuEviterShufps7A:
	cmp eax,7Bh
	jne GMShuEviterShufps7B
	shufps XMM0,XMM1,7Bh
GMShuEviterShufps7B:
	cmp eax,7Ch
	jne GMShuEviterShufps7C
	shufps XMM0,XMM1,7Ch
GMShuEviterShufps7C:
	cmp eax,7Dh
	jne GMShuEviterShufps7D
	shufps XMM0,XMM1,7Dh
GMShuEviterShufps7D:
	cmp eax,7Eh
	jne GMShuEviterShufps7E
	shufps XMM0,XMM1,7Eh
GMShuEviterShufps7E:
	cmp eax,7Fh
	jne GMShuEviterShufps7F
	shufps XMM0,XMM1,7Fh
GMShuEviterShufps7F:

	cmp eax,80h
	jne GMShuEviterShufps80
	shufps XMM0,XMM1,80h
GMShuEviterShufps80:
	cmp eax,81h
	jne GMShuEviterShufps81
	shufps XMM0,XMM1,81h
GMShuEviterShufps81:
	cmp eax,82h
	jne GMShuEviterShufps82
	shufps XMM0,XMM1,82h
GMShuEviterShufps82:
	cmp eax,83h
	jne GMShuEviterShufps83
	shufps XMM0,XMM1,83h
GMShuEviterShufps83:
	cmp eax,84h
	jne GMShuEviterShufps84
	shufps XMM0,XMM1,84h
GMShuEviterShufps84:
	cmp eax,85h
	jne GMShuEviterShufps85
	shufps XMM0,XMM1,85h
GMShuEviterShufps85:
	cmp eax,86h
	jne GMShuEviterShufps86
	shufps XMM0,XMM1,86h
GMShuEviterShufps86:
	cmp eax,87h
	jne GMShuEviterShufps87
	shufps XMM0,XMM1,87h
GMShuEviterShufps87:
	cmp eax,88h
	jne GMShuEviterShufps88
	shufps XMM0,XMM1,88h
GMShuEviterShufps88:
	cmp eax,89h
	jne GMShuEviterShufps89
	shufps XMM0,XMM1,89h
GMShuEviterShufps89:

;
		cmp eax,8Ah
		jne GMShuEviterShufps8A
		shufps XMM0,XMM1,8Ah
GMShuEviterShufps8A:

;
		cmp eax,8Bh
		jne GMShuEviterShufps8B
		shufps XMM0,XMM1,8Bh
GMShuEviterShufps8B:

;
		cmp eax,8Ch
		jne GMShuEviterShufps8C
		shufps XMM0,XMM1,8Ch
GMShuEviterShufps8C:

;
		cmp eax,8Dh
		jne GMShuEviterShufps8D
		shufps XMM0,XMM1,8Dh
GMShuEviterShufps8D:

;
		cmp eax,8Eh
		jne GMShuEviterShufps8E
		shufps XMM0,XMM1,8Eh
GMShuEviterShufps8E:

;
		cmp eax,8Fh
		jne GMShuEviterShufps8F
		shufps XMM0,XMM1,8Fh
GMShuEviterShufps8F:

;
		cmp eax,90h
		jne GMShuEviterShufps90
		shufps XMM0,XMM1,90h
GMShuEviterShufps90:

;
		cmp eax,91h
		jne GMShuEviterShufps91
		shufps XMM0,XMM1,91h
GMShuEviterShufps91:

;
		cmp eax,92h
		jne GMShuEviterShufps92
		shufps XMM0,XMM1,92h
GMShuEviterShufps92:

;
		cmp eax,93h
		jne GMShuEviterShufps93
		shufps XMM0,XMM1,93h
GMShuEviterShufps93:

;
		cmp eax,94h
		jne GMShuEviterShufps94
		shufps XMM0,XMM1,94h
GMShuEviterShufps94:

;
		cmp eax,95h
		jne GMShuEviterShufps95
		shufps XMM0,XMM1,95h
GMShuEviterShufps95:

;
		cmp eax,96h
		jne GMShuEviterShufps96
		shufps XMM0,XMM1,96h
GMShuEviterShufps96:

;
		cmp eax,97h
		jne GMShuEviterShufps97
		shufps XMM0,XMM1,97h
GMShuEviterShufps97:

;
		cmp eax,98h
		jne GMShuEviterShufps98
		shufps XMM0,XMM1,98h
GMShuEviterShufps98:

;
		cmp eax,99h
		jne GMShuEviterShufps99
		shufps XMM0,XMM1,99h
GMShuEviterShufps99:

;
		cmp eax,9Ah
		jne GMShuEviterShufps9A
		shufps XMM0,XMM1,9Ah
GMShuEviterShufps9A:

;
		cmp eax,9Bh
		jne GMShuEviterShufps9B
		shufps XMM0,XMM1,9Bh
GMShuEviterShufps9B:

;
		cmp eax,9Ch
		jne GMShuEviterShufps9C
		shufps XMM0,XMM1,9Ch
GMShuEviterShufps9C:

;
		cmp eax,9Dh
		jne GMShuEviterShufps9D
		shufps XMM0,XMM1,9Dh
GMShuEviterShufps9D:

;
		cmp eax,9Eh
		jne GMShuEviterShufps9E
		shufps XMM0,XMM1,9Eh
GMShuEviterShufps9E:

;
		cmp eax,9Fh
		jne GMShuEviterShufps9F
		shufps XMM0,XMM1,9Fh
GMShuEviterShufps9F:

;
		cmp eax,0A0h
		jne GMShuEviterShufpsA0
		shufps XMM0,XMM1,0A0h
GMShuEviterShufpsA0:

;
		cmp eax,0A1h
		jne GMShuEviterShufpsA1
		shufps XMM0,XMM1,0A1h
GMShuEviterShufpsA1:

;
		cmp eax,0A2h
		jne GMShuEviterShufpsA2
		shufps XMM0,XMM1,0A2h
GMShuEviterShufpsA2:

;
		cmp eax,0A3h
		jne GMShuEviterShufpsA3
		shufps XMM0,XMM1,0A3h
GMShuEviterShufpsA3:

;
		cmp eax,0A4h
		jne GMShuEviterShufpsA4
		shufps XMM0,XMM1,0A4h
GMShuEviterShufpsA4:

;
		cmp eax,0A5h
		jne GMShuEviterShufpsA5
		shufps XMM0,XMM1,0A5h
GMShuEviterShufpsA5:

;
		cmp eax,0A6h
		jne GMShuEviterShufpsA6
		shufps XMM0,XMM1,0A6h
GMShuEviterShufpsA6:

;
		cmp eax,0A7h
		jne GMShuEviterShufpsA7
		shufps XMM0,XMM1,0A7h
GMShuEviterShufpsA7:

;
		cmp eax,0A8h
		jne GMShuEviterShufpsA8
		shufps XMM0,XMM1,0A8h
GMShuEviterShufpsA8:

;
		cmp eax,0A9h
		jne GMShuEviterShufpsA9
		shufps XMM0,XMM1,0A9h
GMShuEviterShufpsA9:

;
		cmp eax,0AAh
		jne GMShuEviterShufpsAA
		shufps XMM0,XMM1,0AAh
GMShuEviterShufpsAA:

;
		cmp eax,0ABh
		jne GMShuEviterShufpsAB
		shufps XMM0,XMM1,0ABh
GMShuEviterShufpsAB:

;
		cmp eax,0ACh
		jne GMShuEviterShufpsAC
		shufps XMM0,XMM1,0ACh
GMShuEviterShufpsAC:

;
		cmp eax,0ADh
		jne GMShuEviterShufpsAD
		shufps XMM0,XMM1,0ADh
GMShuEviterShufpsAD:

;
		cmp eax,0AEh
		jne GMShuEviterShufpsAE
		shufps XMM0,XMM1,0AEh
GMShuEviterShufpsAE:

;
		cmp eax,0AFh
		jne GMShuEviterShufpsAF
		shufps XMM0,XMM1,0AFh
GMShuEviterShufpsAF:

;
		cmp eax,0B0h
		jne GMShuEviterShufpsB0
		shufps XMM0,XMM1,0B0h
GMShuEviterShufpsB0:

;
		cmp eax,0B1h
		jne GMShuEviterShufpsB1
		shufps XMM0,XMM1,0B1h
GMShuEviterShufpsB1:

;
		cmp eax,0B2h
		jne GMShuEviterShufpsB2
		shufps XMM0,XMM1,0B2h
GMShuEviterShufpsB2:

;
		cmp eax,0B3h
		jne GMShuEviterShufpsB3
		shufps XMM0,XMM1,0B3h
GMShuEviterShufpsB3:

;
		cmp eax,0B4h
		jne GMShuEviterShufpsB4
		shufps XMM0,XMM1,0B4h
GMShuEviterShufpsB4:

;
		cmp eax,0B5h
		jne GMShuEviterShufpsB5
		shufps XMM0,XMM1,0B5h
GMShuEviterShufpsB5:

;
		cmp eax,0B6h
		jne GMShuEviterShufpsB6
		shufps XMM0,XMM1,0B6h
GMShuEviterShufpsB6:

;
		cmp eax,0B7h
		jne GMShuEviterShufpsB7
		shufps XMM0,XMM1,0B7h
GMShuEviterShufpsB7:

;
		cmp eax,0B8h
		jne GMShuEviterShufpsB8
		shufps XMM0,XMM1,0B8h
GMShuEviterShufpsB8:

;
		cmp eax,0B9h
		jne GMShuEviterShufpsB9
		shufps XMM0,XMM1,0B9h
GMShuEviterShufpsB9:

;
		cmp eax,0BAh
		jne GMShuEviterShufpsBA
		shufps XMM0,XMM1,0BAh
GMShuEviterShufpsBA:

;
		cmp eax,0BBh
		jne GMShuEviterShufpsBB
		shufps XMM0,XMM1,0BBh
GMShuEviterShufpsBB:

;
		cmp eax,0BCh
		jne GMShuEviterShufpsBC
		shufps XMM0,XMM1,0BCh
GMShuEviterShufpsBC:

;
		cmp eax,0BDh
		jne GMShuEviterShufpsBD
		shufps XMM0,XMM1,0BDh
GMShuEviterShufpsBD:

;
		cmp eax,0BEh
		jne GMShuEviterShufpsBE
		shufps XMM0,XMM1,0BEh
GMShuEviterShufpsBE:

;
		cmp eax,0BFh
		jne GMShuEviterShufpsBF
		shufps XMM0,XMM1,0BFh
GMShuEviterShufpsBF:

;
		cmp eax,0C0h
		jne GMShuEviterShufpsC0
		shufps XMM0,XMM1,0C0h
GMShuEviterShufpsC0:

;
		cmp eax,0C1h
		jne GMShuEviterShufpsC1
		shufps XMM0,XMM1,0C1h
GMShuEviterShufpsC1:

;
		cmp eax,0C2h
		jne GMShuEviterShufpsC2
		shufps XMM0,XMM1,0C2h
GMShuEviterShufpsC2:

;
		cmp eax,0C3h
		jne GMShuEviterShufpsC3
		shufps XMM0,XMM1,0C3h
GMShuEviterShufpsC3:

;
		cmp eax,0C4h
		jne GMShuEviterShufpsC4
		shufps XMM0,XMM1,0C4h
GMShuEviterShufpsC4:

;
		cmp eax,0C5h
		jne GMShuEviterShufpsC5
		shufps XMM0,XMM1,0C5h
GMShuEviterShufpsC5:

;
		cmp eax,0C6h
		jne GMShuEviterShufpsC6
		shufps XMM0,XMM1,0C6h
GMShuEviterShufpsC6:

;
		cmp eax,0C7h
		jne GMShuEviterShufpsC7
		shufps XMM0,XMM1,0C7h
GMShuEviterShufpsC7:

;
		cmp eax,0C8h
		jne GMShuEviterShufpsC8
		shufps XMM0,XMM1,0C8h
GMShuEviterShufpsC8:

;
		cmp eax,0C9h
		jne GMShuEviterShufpsC9
		shufps XMM0,XMM1,0C9h
GMShuEviterShufpsC9:

;
		cmp eax,0CAh
		jne GMShuEviterShufpsCA
		shufps XMM0,XMM1,0CAh
GMShuEviterShufpsCA:

;
		cmp eax,0CBh
		jne GMShuEviterShufpsCB
		shufps XMM0,XMM1,0CBh
GMShuEviterShufpsCB:

;
		cmp eax,0CCh
		jne GMShuEviterShufpsCC
		shufps XMM0,XMM1,0CCh
GMShuEviterShufpsCC:

;
		cmp eax,0CDh
		jne GMShuEviterShufpsCD
		shufps XMM0,XMM1,0CDh
GMShuEviterShufpsCD:

;
		cmp eax,0CEh
		jne GMShuEviterShufpsCE
		shufps XMM0,XMM1,0CEh
GMShuEviterShufpsCE:

;
		cmp eax,0CFh
		jne GMShuEviterShufpsCF
		shufps XMM0,XMM1,0CFh
GMShuEviterShufpsCF:

;
		cmp eax,0D0h
		jne GMShuEviterShufpsD0
		shufps XMM0,XMM1,0D0h
GMShuEviterShufpsD0:

;
		cmp eax,0D1h
		jne GMShuEviterShufpsD1
		shufps XMM0,XMM1,0D1h
GMShuEviterShufpsD1:

;
		cmp eax,0D2h
		jne GMShuEviterShufpsD2
		shufps XMM0,XMM1,0D2h
GMShuEviterShufpsD2:

;
		cmp eax,0D3h
		jne GMShuEviterShufpsD3
		shufps XMM0,XMM1,0D3h
GMShuEviterShufpsD3:

;
		cmp eax,0D4h
		jne GMShuEviterShufpsD4
		shufps XMM0,XMM1,0D4h
GMShuEviterShufpsD4:

;
		cmp eax,0D5h
		jne GMShuEviterShufpsD5
		shufps XMM0,XMM1,0D5h
GMShuEviterShufpsD5:

;
		cmp eax,0D6h
		jne GMShuEviterShufpsD6
		shufps XMM0,XMM1,0D6h
GMShuEviterShufpsD6:

;
		cmp eax,0D7h
		jne GMShuEviterShufpsD7
		shufps XMM0,XMM1,0D7h
GMShuEviterShufpsD7:

;
		cmp eax,0D8h
		jne GMShuEviterShufpsD8
		shufps XMM0,XMM1,0D8h
GMShuEviterShufpsD8:

;
		cmp eax,0D9h
		jne GMShuEviterShufpsD9
		shufps XMM0,XMM1,0D9h
GMShuEviterShufpsD9:

;
		cmp eax,0DAh
		jne GMShuEviterShufpsDA
		shufps XMM0,XMM1,0DAh
GMShuEviterShufpsDA:

;
		cmp eax,0DBh
		jne GMShuEviterShufpsDB
		shufps XMM0,XMM1,0DBh
GMShuEviterShufpsDB:

;
		cmp eax,0DCh
		jne GMShuEviterShufpsDC
		shufps XMM0,XMM1,0DCh
GMShuEviterShufpsDC:

;
		cmp eax,0DDh
		jne GMShuEviterShufpsDD
		shufps XMM0,XMM1,0DDh
GMShuEviterShufpsDD:

;
		cmp eax,0DEh
		jne GMShuEviterShufpsDE
		shufps XMM0,XMM1,0DEh
GMShuEviterShufpsDE:

;
		cmp eax,0DFh
		jne GMShuEviterShufpsDF
		shufps XMM0,XMM1,0DFh
GMShuEviterShufpsDF:

;
		cmp eax,0E0h
		jne GMShuEviterShufpsE0
		shufps XMM0,XMM1,0E0h
GMShuEviterShufpsE0:

;
		cmp eax,0E1h
		jne GMShuEviterShufpsE1
		shufps XMM0,XMM1,0E1h
GMShuEviterShufpsE1:

;
		cmp eax,0E2h
		jne GMShuEviterShufpsE2
		shufps XMM0,XMM1,0E2h
GMShuEviterShufpsE2:

;
		cmp eax,0E3h
		jne GMShuEviterShufpsE3
		shufps XMM0,XMM1,0E3h
GMShuEviterShufpsE3:

;
		cmp eax,0E4h
		jne GMShuEviterShufpsE4
		shufps XMM0,XMM1,0E4h
GMShuEviterShufpsE4:

;
		cmp eax,0E5h
		jne GMShuEviterShufpsE5
		shufps XMM0,XMM1,0E5h
GMShuEviterShufpsE5:

;
		cmp eax,0E6h
		jne GMShuEviterShufpsE6
		shufps XMM0,XMM1,0E6h
GMShuEviterShufpsE6:

;
		cmp eax,0E7h
		jne GMShuEviterShufpsE7
		shufps XMM0,XMM1,0E7h
GMShuEviterShufpsE7:

;
		cmp eax,0E8h
		jne GMShuEviterShufpsE8
		shufps XMM0,XMM1,0E8h
GMShuEviterShufpsE8:

;
		cmp eax,0E9h
		jne GMShuEviterShufpsE9
		shufps XMM0,XMM1,0E9h
GMShuEviterShufpsE9:

;
		cmp eax,0EAh
		jne GMShuEviterShufpsEA
		shufps XMM0,XMM1,0EAh
GMShuEviterShufpsEA:

;
		cmp eax,0EBh
		jne GMShuEviterShufpsEB
		shufps XMM0,XMM1,0EBh
GMShuEviterShufpsEB:

;
		cmp eax,0ECh
		jne GMShuEviterShufpsEC
		shufps XMM0,XMM1,0ECh
GMShuEviterShufpsEC:

;
		cmp eax,0EDh
		jne GMShuEviterShufpsED
		shufps XMM0,XMM1,0EDh
GMShuEviterShufpsED:

;
		cmp eax,0EEh
		jne GMShuEviterShufpsEE
		shufps XMM0,XMM1,0EEh
GMShuEviterShufpsEE:

;
		cmp eax,0EFh
		jne GMShuEviterShufpsEF
		shufps XMM0,XMM1,0EFh
GMShuEviterShufpsEF:

;
		cmp eax,0F0h
		jne GMShuEviterShufpsF0
		shufps XMM0,XMM1,0F0h
GMShuEviterShufpsF0:

;
		cmp eax,0F1h
		jne GMShuEviterShufpsF1
		shufps XMM0,XMM1,0F1h
GMShuEviterShufpsF1:

;
		cmp eax,0F2h
		jne GMShuEviterShufpsF2
		shufps XMM0,XMM1,0F2h
GMShuEviterShufpsF2:

;
		cmp eax,0F3h
		jne GMShuEviterShufpsF3
		shufps XMM0,XMM1,0F3h
GMShuEviterShufpsF3:

;
		cmp eax,0F4h
		jne GMShuEviterShufpsF4
		shufps XMM0,XMM1,0F4h
GMShuEviterShufpsF4:

;
		cmp eax,0F5h
		jne GMShuEviterShufpsF5
		shufps XMM0,XMM1,0F5h
GMShuEviterShufpsF5:

;
		cmp eax,0F6h
		jne GMShuEviterShufpsF6
		shufps XMM0,XMM1,0F6h
GMShuEviterShufpsF6:

;
		cmp eax,0F7h
		jne GMShuEviterShufpsF7
		shufps XMM0,XMM1,0F7h
GMShuEviterShufpsF7:

;
		cmp eax,0F8h
		jne GMShuEviterShufpsF8
		shufps XMM0,XMM1,0F8h
GMShuEviterShufpsF8:

;
		cmp eax,0F9h
		jne GMShuEviterShufpsF9
		shufps XMM0,XMM1,0F9h
GMShuEviterShufpsF9:

;
		cmp eax,0FAh
		jne GMShuEviterShufpsFA
		shufps XMM0,XMM1,0FAh
GMShuEviterShufpsFA:

;
		cmp eax,0FBh
		jne GMShuEviterShufpsFB
		shufps XMM0,XMM1,0FBh
GMShuEviterShufpsFB:

;
		cmp eax,0FCh
		jne GMShuEviterShufpsFC
		shufps XMM0,XMM1,0FCh
GMShuEviterShufpsFC:

;
		cmp eax,0FDh
		jne GMShuEviterShufpsFD
		shufps XMM0,XMM1,0FDh
GMShuEviterShufpsFD:

;
		cmp eax,0FEh
		jne GMShuEviterShufpsFE
		shufps XMM0,XMM1,0FEh
GMShuEviterShufpsFE:

;
		cmp eax,0FFh
		jne GMShuEviterShufpsFF
		shufps XMM0,XMM1,0FFh
GMShuEviterShufpsFF:

; sauvegarder le rsultat obtenu
		movaps OWORD PTR [ebx],XMM0						;; sauvegarder les dwords contenant les rsultats
; convertir les valeurs en chanes ascii
		mov eax,OFFSET Shuffle_Resultats									;; ) convertir les ieee en chanes
		mov edi,OFFSET Shuffle_Chaine_Resultats								;; )
		call Shuffle_Sse_ConvertirIeeeSimplesEnChaineDecimaleCustomisee			;; )
;		mov eax,OFFSET Shuffle_Valeurs_0									;; )
;		mov edi,OFFSET Shuffle_Chaine_Valeurs_0								;; )
;		invoke Shuffle_Sse_ConvertirIeeeSimplesEnChaineDecimaleCustomisee		;; )
;		mov eax,OFFSET Shuffle_Valeurs_1									;; )
;		mov edi,OFFSET Shuffle_Chaine_Valeurs_1								;; )
;		invoke Shuffle_Sse_ConvertirIeeeSimplesEnChaineDecimaleCustomisee		;; )
; afficher le rsultat
		invoke SetDlgItemText,HWndGMShu,Rsrc_IDC_Shuffle_Resultats,ADDR Shuffle_Chaine_Resultats		;; ) assigner les chanes obtenues aux controls correspondants
		invoke SetDlgItemText,HWndGMShu,Rsrc_IDC_Shuffle_Valeurs0,ADDR Shuffle_Chaine_Valeurs_0		;; )
		invoke SetDlgItemText,HWndGMShu,Rsrc_IDC_Shuffle_Valeurs1,ADDR Shuffle_Chaine_Valeurs_1		;; )

	ret												;; retourner
GMShuFinBoiteCombo:

;
	ret												;; retourner
GMShuFinCommandes:
		mov eax,Message								;; replacer Message en eax (modification possible)


;
; fermeture de l'application ?
;
		cmp eax,WM_CLOSE								;; message de fermeture reu ?
		jne GMShuPasFermeture							;; si ce n'est pas le cas, aller GMShuPasFermeture
		jmp GMShuSortir								;; sinon, idem WM_DESTROY
	ret												;; retourner
GMShuPasFermeture:


;
; quitter l'application
;
		cmp eax,WM_DESTROY								;; fermeture de l'application par la croix ?
		jne GMShuPasQuitter								;; si ce n'est pas le cas, aller GMShuPasQuitter
GMShuSortir:
		bts Temoins_Boites_De_Dialogue,0					;; placer le tmoin de la boite de dialogue pour quitter (bit 0)
		invoke EnableWindow,HWndGMShu,FALSE
		invoke DialogBoxParam,Instance_Boites_Dialogue,Rsrc_IDD_Quitter,0,ADDR GestionnaireMessagesBoitesDialogue,0
		invoke EnableWindow,HWndGMShu,TRUE
	ret												;; retourner
GMShuPasQuitter:


;
; traitement par dfaut pour les boites de dialogue
;
		xor eax,eax									;; effacer eax
	ret												;; retourner
GestionnaireMessagesBoiteDialogueInstructionsShuffle ENDP


ALIGN 16
;
; gestionnaire des messages des boites de dialogue
;
GestionnaireMessagesBoitesDialogue PROC HWndDlg:HWND,Message:UINT,WParam:WPARAM,LParam:LPARAM

		mov eax,Message								;; placer Message en eax (c'est plus rapide si le nombre de tests  effectuer est consquent)

		cmp eax,WM_COMMAND								;; une commande ?
		jne GMBDFinCommandes							;; si ce n'est pas le cas, aller GMBDFinCommandes
		mov eax,WParam									;; placer WParam en eax (c'est plus rapide si le nombre de tests  effectuer est consquent)

;
; boite de dialogue pour microprocesseur insuffisant
;

; Il est temps d'en changer...
		cmp eax,Rsrc_IDC_Temps_Changer					;; il est temps d'en changer est cliqu ?
		jne GMBDPasTempsChangerMicro						;; si ce n'est pas le cas, aller GMBDPasTempsChangerMicro
		invoke EndDialog,HWndDlg,0						;; sinon, fermer la boite de dialogue
		invoke PostQuitMessage,NULL						;; et poster le message de sortie
	ret												;; retourner
GMBDPasTempsChangerMicro:

;
; boite de dialogue pour quitter le programme
;

; hum... oui
		cmp eax,Rsrc_IDC_Hum_Oui							;; Hum... oui est cliqu ?
		jne GMBDPasHumOui								;; si ce n'est pas le cas, aller GMBDPasHumOui
		invoke EndDialog,HWndDlg,0						;; sinon, fermer la boite de dialogue
		invoke PostQuitMessage,NULL						;; et poster le message de sortie
	ret												;; retourner
GMBDPasHumOui:

; Ah a non !
		cmp eax,Rsrc_IDC_Ah_Ca_Non						;; Ah a non ! est cliqu ?
		jne GMBDPasAhCaNon								;; si ce n'est pas le cas, aller GMBDPasAhCaNon
		invoke EndDialog,HWndDlg,0						;; sinon, fermer la boite de dialogue
	ret												;; retourner
GMBDPasAhCaNon:

;
	ret												;; retourner
GMBDFinCommandes:

;
; traitement par dfaut pour les boites de dialogue
;
		xor eax,eax									;; effacer eax (ce sera le traitement par dfaut des messages)
	ret												;; retourner
GestionnaireMessagesBoitesDialogue ENDP


ALIGN 16
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * Point d'entre du programme
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
Shufps_Sse:
;		invoke GetCurrentProcess							;; ) fixer la priorit de notre application  haute
;		invoke SetPriorityClass,eax,HIGH_PRIORITY_CLASS		;; )
		invoke GetCommandLine							;;	) obtenir un pointeur sur la ligne de commande
		mov Pointeur_Ligne_Commandes,eax					;;	) et sauvegarder ce pointeur dans Pointeur_Ligne_Commande
		invoke GetModuleHandle,NULL						;; ) obtenir l'instance de la fentre
		mov Instance_Application,eax						;; ) et sauvegarder le pointeur obtenu dans Instance_Application
;		mov Informations_Fenetre.hInstance,eax				;; ) ainsi que dans notre structure WNDCLASSEX
		invoke GetModuleHandle,NULL						;;	) obtenir l'instance des boites de dialogue
		mov Instance_Boites_Dialogue,eax					;;	) et sauvegarder le pointeur obtenu dans Instance_Boites_Dialogue
;		invoke ShowCursor,FALSE							;; faire disparaitre le pointeur cran
;		mov esi,OFFSET Instance_Memoire					;; ) obtenir une instance mmoire
;		call CreerInstanceMemoire						;; )


;
; ici, on va tester le microprocesseur pour savoir si le minimum requis est disponible (on l'a pas fait avant parcequ'il fallait Pointeur_Fenetre)
;
		call DefinirAptitudesDuProcesseur
; bit 0 = Cpuid support ? 1=oui, 0=non
; bit 1 = Fpu support ? 1=oui, 0=non
; bit 2 = Tsc support ? 1=oui, 0=non
; bit 3 = Cx8 support ? 1=oui, 0=non
; bit 4 = cMov support ? 1=oui, 0=non
; bit 5 = Clfsh support ? 1=oui, 0=non
; bit 6 = Mmx support ? 1=oui, 0=non
; bit 7 = Fxsr support ? 1=oui, 0=non
; bit 8 = Sse support ? 1=oui, 0=non
; bit 9 = Sse2 support ? 1=oui, 0=non
; bit 10 = Htt support ? 1=oui, 0=non
; bit 11 = Sse3 support ? 1=oui, 0=non
;		mov eax,_Temoins_Aptitudes_Du_MicroProcesseur_		;; copier les tmoins obtenus dans eax
;		mov edx,000000000001b							;; cpuid
;		mov edx,000000000011b							;; cpuid + fpu
;		mov edx,000000010011b							;; cpuid + fpu + cmov
;		mov edx,000001010011b							;; cpuid + fpu + cmov + mmx
		mov edx,000101010011b							;; cpuid + fpu + cmov + mmx + sse
;		mov edx,001101010011b							;; cpuid + fpu + cmov + mmx + sse + sse2
;		mov edx,101101010011b							;; cpuid + fpu + cmov + mmx + sse + sse2 + sse3
		and eax,edx									;; ici on ne conserve que les bits  tester dans eax
		cmp eax,edx									;; et on s'asure qu'ils sont tous l
		je MicroprocesseurSuffisant						;; si c'est gal (le microprocesseur a le minimum requis), aller MicroprocesseurSuffisant
; sinon on va afficher la boite de dialogue en consquence
;		invoke ReleaseCapture							;; librer les messages de la souris
;		invoke ShowCursor,Vrai							;; faire rapparaitre le pointeur cran
		invoke DialogBoxParam,Instance_Boites_Dialogue,Rsrc_IDD_Insuffisant,0,ADDR GestionnaireMessagesBoitesDialogue,0
; boucle a effectuer tant que le message envoy par PostQuitMessage n'a pas t reu
MicroprocesseurBoucleMessages:
;		invoke GetMessage,ADDR Informations_Messages_OS,NULL,NULL,NULL		;; pour obtenir les messages provenants de toutes les applications
		invoke GetMessage,ADDR Informations_Messages_OS,NULL,NULL,NULL		;; pour obtenir uniquement les messages concernant notre application
		cmp eax,NULL									;; comparer eax  zro
		je MicroprocesseurInsuffisant						;; si c'est gal  0 (pas de message), aller MicroprocesseurInsuffisant
;		invoke TranslateMessage,ADDR Informations_Messages_OS		;; (optionnel) pour traduire les messages des touches du clavier
		invoke DispatchMessage,ADDR Informations_Messages_OS		;; et dispatcher (mettre  la queue pour que ce soit lu par GestionnaireMessagesBoitesDialogue au moment voulu)
		jmp MicroprocesseurBoucleMessages					;; aller MicroprocesseurBoucleMessages (pour aller lire le message suivant)
MicroprocesseurSuffisant:


;
; sinon, le minimum requis est prsent
;

; appeler la boite de dialogue principale
		invoke DialogBoxParam,Instance_Application,Rsrc_IDD_Shuffle_Fenetre,0,ADDR GestionnaireMessagesBoiteDialogueInstructionsShuffle,0

;
; boucle a effectuer tant que le message envoy par PostQuitMessage n'a pas t reu
;
BoucleMessages:
;		invoke GetMessage,ADDR Informations_Messages_OS,NULL,NULL,NULL		;; pour obtenir les messages provenants de toutes les applications
		invoke GetMessage,ADDR Informations_Messages_OS,NULL,NULL,NULL		;; pour obtenir uniquement les messages concernant notre application
		cmp eax,NULL									;; comparer eax  zro
		je FinBoucleMessages							;; si c'est gal  0 (pas de message), aller FinBoucleMessages
;		invoke TranslateMessage,ADDR Informations_Messages_OS		;; (optionnel) pour traduire les messages des touches du clavier
		invoke DispatchMessage,ADDR Informations_Messages_OS		;; et dispatcher (mettre  la queue pour que ce soit lu par GestionnaireMessagesBoiteDialogueRedefinirAttributs au moment voulu)
		jmp BoucleMessages								;; aller BoucleMessages (pour aller lire le message suivant)
FinBoucleMessages:


;;
;; vider la mmoire (si un bloc  t cr)
;;
;		bt Temoins_Activations,0							;; tester le temoin pour le bloc mmoire
;		jnc EviterViderMemoire							;; si c'est inutilis, aller EviterViderMemoire
;		mov esi,OFFSET Instance_Memoire					;; ) supprimer l'espace mmoire pour notre tampon fichier
;		mov edi,OFFSET Tampon_Bloc_Fichier					;; )
;		call EffacerFichierEnMemoire						;; )
;EviterViderMemoire:


;
; et par ici la sortie...
;
MicroprocesseurInsuffisant:
;		mov esi,OFFSET Instance_Memoire					;; ) supprimer l'intance mmoire
;		call SupprimerInstanceMemoire						;; )
		invoke ExitProcess,Informations_Messages_OS.wParam		;; sortie de l'application
;
; fin du programme
;
END Shufps_Sse

